/*

audio level meter

arguments: fgred fggreen fgblue bgred bggreen bgblue linered linegreen lineblue mode
rej@2uptech.com

*/


post ("_2up_level_meter\n");
autowatch = 1;



sketch.default2d();
var val = 0;
var vbrgb = [0., 0., 0.];
var vfrgb = [0.2, 0.3, 0.9];
var vrgb2 = [0.4,0.6,1.0];
var vmode = 0;
var voutline = 1;

var channels = 8;
var valarray = [0., 0., 0., 0., 0., 0., 0., 0.];
var peakarray = [0., 0., 0., 0., 0., 0., 0., 0.];


// process arguments
if (jsarguments.length>1)
	vfrgb[0] = jsarguments[1]/255.;
if (jsarguments.length>2)
	vfrgb[1] = jsarguments[2]/255.;
if (jsarguments.length>3)
	vfrgb[2] = jsarguments[3]/255.;
if (jsarguments.length>4)
	vbrgb[0] = jsarguments[4]/255.;
if (jsarguments.length>5)
	vbrgb[1] = jsarguments[5]/255.;
if (jsarguments.length>6)
	vbrgb[2] = jsarguments[6]/255.;
if (jsarguments.length>7)
	vrgb2[0] = jsarguments[7]/255.;
if (jsarguments.length>8)
	vrgb2[1] = jsarguments[8]/255.;
if (jsarguments.length>9)
	vrgb2[2] = jsarguments[9]/255.;
if (jsarguments.length>10)
	vmode = jsarguments[10];
if (jsarguments.length>11)
	voutline = jsarguments[11];

draw();

function draw()
{
	var x1, x2, y;
	var p_screen, p_w1, p_w2, p_w3, p_w4;
	var width = box.rect[2] - box.rect[0];
	var height = box.rect[3] - box.rect[1];
	var aspect = width/height;
	var space = 4;
	
	var sliderspace = Math.floor(width/channels);
	var sliderwidth = sliderspace - space;
	var segmentheight = 0.04;
	var v,j;
	
	with (sketch) 
	{
		//scale everything to box size
		glmatrixmode("modelview");
		glpushmatrix();
		glscale(aspect,1,1);
		glenable("line_smooth");

		// erase background
		glclearcolor(vbrgb);
		glclear();	
		shapeslice(1,1);
		
		for (i=0; i<channels; i++)
		{
			x1 = space + sliderspace * i ;
			x2 = x1 + sliderwidth ;
			v = Math.min(Math.max(0.,valarray[i]),1.);
			
			for (j=0.; j<v; j+= segmentheight*2)
			{
				y = (1.- j) * height;
				
				p_w1 = sketch.screentoworld(x1, y);
				p_w2 = sketch.screentoworld(x2, y);
				
				beginstroke("basic2d");
				strokeparam("order",1)
				strokeparam("slices",2)
				strokeparam("color",vfrgb);
				strokeparam("scale",segmentheight);
				strokepoint(p_w1);
				strokepoint(p_w2);
				endstroke();
			}	
			
			v = Math.min(Math.max(0.,peakarray[i]),1.);
			
			for (j=0.; j<v; j+= segmentheight*2)
			{
			}
			
			{
				y = (1.- j) * height;
				
				p_w1 = sketch.screentoworld(x1, y);
				p_w2 = sketch.screentoworld(x2, y);
				
				beginstroke("basic2d");
				strokeparam("order",1)
				strokeparam("slices",2)
				strokeparam("color",vrgb2);
				strokeparam("scale",segmentheight);
				strokepoint(p_w1);
				strokepoint(p_w2);
				endstroke();
			}	
			
			
					
		}		

		//reset transformation matrix
		glmatrixmode("modelview");
		glpopmatrix();
	}
}

function bang()
{
	draw();
	refresh();
}

function msg_float(v)
{
	val = Math.min(Math.max(0,v),1);
	bang();
}


function amps(v)
{
	var len = arguments.length;
	var f, i;
	
	for (i=0; i<len; i++)
	{
		f = arguments[i];
		valarray[i] = Math.min(Math.max(0.,f),1.);
	}
	bang();
}

function peaks(v)
{
	var len = arguments.length;
	var f, i;
	
	for (i=0; i<len; i++)
	{
		f = arguments[i];
		peakarray[i] = Math.min(Math.max(0.,f),1.);
	}
}

function fsaa(v)
{
	sketch.fsaa = v;
	bang();
}

function frgb(r,g,b)
{
	vfrgb[0] = r/255.;
	vfrgb[1] = g/255.;
	vfrgb[2] = b/255.;
	draw();
	refresh();
}

function rgb2(r,g,b)
{
	vrgb2[0] = r/255.;
	vrgb2[1] = g/255.;
	vrgb2[2] = b/255.;
	draw();
	refresh();
}

function brgb(r,g,b)
{
	vbrgb[0] = r/255.;
	vbrgb[1] = g/255.;
	vbrgb[2] = b/255.;
	draw();
	refresh();
}

function mode(v)
{
	vmode = v;
	draw();
	refresh();
}

function outline(v)
{
	voutline = v;
	draw();
	refresh();
}

function setvalueof(v)
{
	msg_float(v);
}

function getvalueof()
{
	return val;
}


function onresize(w,h)
{
	draw();
	refresh();
}
onresize.local = 1; //private
