/*

range slider

arguments: fgred fggreen fgblue bgred bggreen bgblue linered linegreen lineblue mode

*/


post ("_2up_range_slider.\n");
autowatch = 1;

var	MIN_SEGMENT = 5;

sketch.default2d();
var valarray = [0., 1.];
var inputval = [0., 1.];
var vbrgb = [0., 0.25, 0.];
var vfrgb = [0.,1.,0.];
var pointer_rgb = [0.,1.,0.];
var vrgb2 = [0.,0.5,0.];
var vmode = 0;
var voutline = 1;

var prevdown = 0;
var mousedown = 0;
var stilldown = 0;
var glow = 0;
var closest = 0;
var grab = -1;

var g_pointer_enable = 1;
var pointer_val = 0.;
var pointer_rotate = 1.;
var g_playing = 0;

// process arguments
if (jsarguments.length>1)
	vfrgb[0] = jsarguments[1]/255.;
if (jsarguments.length>2)
	vfrgb[1] = jsarguments[2]/255.;
if (jsarguments.length>3)
	vfrgb[2] = jsarguments[3]/255.;
if (jsarguments.length>4)
	vbrgb[0] = jsarguments[4]/255.;
if (jsarguments.length>5)
	vbrgb[1] = jsarguments[5]/255.;
if (jsarguments.length>6)
	vbrgb[2] = jsarguments[6]/255.;
if (jsarguments.length>7)
	vrgb2[0] = jsarguments[7]/255.;
if (jsarguments.length>8)
	vrgb2[1] = jsarguments[8]/255.;
if (jsarguments.length>9)
	vrgb2[2] = jsarguments[9]/255.;
if (jsarguments.length>10)
	vmode = jsarguments[10];
if (jsarguments.length>11)
	voutline = jsarguments[11];

draw();

function draw()
{
	var width = box.rect[2] - box.rect[0];
	var height = box.rect[3] - box.rect[1];
	var aspect = width/height;
	var xa, xb, ya, yb;
	var bracketpx = 5; 
	var bracketw = bracketpx / width;
	var pixel = 1 / width;
	var i;
	
	with (sketch) 
	{
		//scale everything to box size
		glmatrixmode("modelview");
		glpushmatrix();
		glscale(aspect*2,2.,1.);
		gltranslate(-0.5, -0.5, 0.);

		// erase background
		glclearcolor(vbrgb);
		glclear();			

		//draw bar
		glcolor(vrgb2);
		shapeslice(1,1);

		xa = valarray[0]; 
		xb = valarray[1];
		ya = 0.1;
		yb = 0.9;

		quad(xa, ya, 0, xb, ya, 0, xb, yb, 0, xa, yb, 0);

		if (glow) 
		{
			glcolor(vfrgb);
			// left bracket
			if (closest == 0)
			{
				xa = xb = valarray[closest] + pixel;
				ya = 0.1;
				yb = 0.9;
				linesegment(xa, ya, 0, xb, yb, 0);
				xb = xa + bracketw;
				ya = yb = 0.1;
				linesegment(xa, ya, 0, xb, yb, 0);
				ya = yb = 0.9;
				linesegment(xa, ya, 0, xb, yb, 0);
			}
			// right
			else if (closest == valarray.length-1)
			{
				xa = xb = valarray[closest] - pixel;
				ya = 0.1;
				yb = 0.9;
				linesegment(xa, ya, 0, xb, yb, 0);
				xb = xa - bracketw;
				ya = yb = 0.1;
				linesegment(xa, ya, 0, xb, yb, 0);
				ya = yb = 0.9;
				linesegment(xa, ya, 0, xb, yb, 0);
			}
			// other
			else
			{
				xa = xb = valarray[closest];
				ya = 0.1;
				yb = 0.9;
				linesegment(xa, ya, 0, xb, yb, 0);
			}
		}
		
		if (g_pointer_enable)
		{
			// pulsate
			var p;
			if (g_playing)
			{
				p = 2.*Math.abs(pointer_rotate-0.5);
			}
			else
			{
				p = 1.;
			}
			for(i=0; i<3; i++)
			{
				pointer_rgb[i] = vfrgb[i]*p + vrgb2[i]*(1.-p);
			}
			glcolor(pointer_rgb);
			xa = xb = pointer_val;
			ya = 0.1;
			yb = 0.9;
			linesegment(xa, ya, 0, xb, yb, 0);
		}
	
		//reset transformation matrix
		glmatrixmode("modelview");
		glpopmatrix();
	}
}


function animate(time)
{
	var t = time * 0.001;
	pointer_rotate = t - Math.floor(t);
}



function playing(p)
{
	g_playing = p;
}


function pointer_enable(v)
{
	g_pointer_enable = v;
	draw();
	refresh();
}

function pointer(v)
{
	pointer_val = v;
	draw();
	refresh();
}


function bang()
{
	draw();
	refresh();
	outlet(0,valarray);
}

function list(v)
{
	var len = arguments.length;
	var f, i;
	
	for (i=0; i<len; i++)
	{
		f = arguments[i];
		valarray[i] = Math.min(Math.max(0.,f),1.);
	}
	notifyclients();
	bang();
}

function set_array(a)
{
	var len = a.length;
	var f, i;
	
	for (i=0; i<len; i++)
	{
		f = a[i];
		valarray[i] = Math.min(Math.max(0.,f),1.);
	}
	notifyclients();
	bang();
}

function fsaa(v)
{
	sketch.fsaa = v;
	bang();
}

function frgb(r,g,b)
{
	vfrgb[0] = r/255.;
	vfrgb[1] = g/255.;
	vfrgb[2] = b/255.;
	draw();
	refresh();
}

function rgb2(r,g,b)
{
	vrgb2[0] = r/255.;
	vrgb2[1] = g/255.;
	vrgb2[2] = b/255.;
	draw();
	refresh();
}

function brgb(r,g,b)
{
	vbrgb[0] = r/255.;
	vbrgb[1] = g/255.;
	vbrgb[2] = b/255.;
	draw();
	refresh();
}

function mode(v)
{
	vmode = v;
	draw();
	refresh();
}

function outline(v)
{
	voutline = v;
	draw();
	refresh();
}

function setvalueof(v)
{
	msg_float(v);
}

function getvalueof()
{
	return valarray;
}


function onidle(x,y,button,cmd,shift,capslock,option,ctrl)
{
	ondrag(x,y,button,cmd,shift,capslock,option,ctrl);
	if (glow)
	{
		draw();
		refresh();
	}
}
onidle.local = 1; //private. could be left public to permit "synthetic" events

function onidleout(x,y,button,cmd,shift,capslock,option,ctrl)
{
	if (glow)
	{
		glow = 0;
		draw();
		refresh();
	}
}
onidleout.local = 1; //private. could be left public to permit "synthetic" events


function onclick(x,y,button,cmd,shift,capslock,option,ctrl)
{
	ondrag(x,y,button,cmd,shift,capslock,option,ctrl);
}
onclick.local = 1; //private. could be left public to permit "synthetic" events

function ondrag(x,y,button,cmd,shift,capslock,option,ctrl)
{
	var f,a,i;
	var lx, ly;
	var width = box.rect[2] - box.rect[0];
	var height = box.rect[3] - box.rect[1];
	var aspect = width/height;
	var e = (MIN_SEGMENT / width);
	var intersect;
	var dist, mindist;
	var do_set = 0;
	
	a = sketch.screentoworld(x,y); 
	lx = ((a[0]/aspect) +1.) * 0.5; 
	ly = ((a[1]) +1.) * 0.5; 
	
	intersect = ((0<lx)&&(lx<1)&&(0<ly)&&(ly<1)); 
	prevdown = mousedown;
	mousedown = button;
	
	// command key: move pointer
	if (cmd && intersect && g_pointer_enable)
	{
		glow = 0;	
		draw();
		refresh();
		if (mousedown)
		{
			pointer_val = lx;
			outlet(0, "pointer", pointer_val);
		}
	}
	else
	{	
		if (intersect)
		{
			stilldown = mousedown && prevdown;
		}
		else
		{
			stilldown = stilldown && mousedown;
		}
		
		for(i=0; i<valarray.length; i++)
		{
			inputval[i] = valarray[i];
		}
		
		// get closest
		closest = -1;
		for(i=0; i<valarray.length; i++)
		{
			dist = Math.abs(valarray[i] - lx);
			if ((dist < mindist) || (closest == -1))
			{
				mindist = dist;
				closest = i;
			}
		}
		
		// set glow
		glow = (intersect || stilldown);
		
	
		if ((intersect && mousedown) && (!prevdown)) // first click
		{
			grab = closest;
			inputval[grab] = lx;
			do_set = 1;
		}
		
		if (stilldown)
		{	
			// set grabbed
			inputval[grab] = lx;
			do_set = 1;
			
			// nudge others if needed
			for(i=0; i<valarray.length; i++)
			{
				if (i < grab)
				{
					if (inputval[i] > inputval[grab] - e)
					{
						inputval[i] = inputval[grab] - e;
					}
					// add cascading nudge down the line if more than 2 segments. 
				}
				else if (i > grab)
				{
					if (inputval[i] < inputval[grab] + e)
					{
						inputval[i] = inputval[grab] + e;
					}
					// ditto
				}
			}
		}
		if (do_set)
		{
			set_array(inputval); // set new values with clipping + refresh
		}
	}
}
ondrag.local = 1; //private. could be left public to permit "synthetic" events


function onresize(w,h)
{
	draw();
	refresh();
}
onresize.local = 1; //private
