
// handle plugins for render_node

post ("__plugins\n");
autowatch = 1;

// global varables and code
inlets = 1;
outlets = 1;

var gPlugNames = new Array();
sendglobal("grn_plugin_count", 0);

function reset()
{
	gPlugNames.length = 0;
	pingplugs();
}

// rebuild chain when any plugin is opened
function hello()
{
	reset();
}

// send global via attached forward obj
function sendglobal(chan, msg)
{
	outlet(0, "send", chan);
	outlet(0, msg);
}


function pingplugs()
{
	sendglobal("grn_ping_plugins", "bang");
}


function addplug(name)
{
	post ("adding plugin", name, "\n");
	gPlugNames.push(name);	
	setplugs();
}

function removeplug(name)
{
	var i;
	for(i=0; i < gPlugNames.length; i++)
	{
		if (name == gPlugNames[i])
		{
			post ("removing plugin", name, "\n");
			gPlugNames.splice(i, 1);	
		}
	}
	setplugs();
}


function setplugs()
{
	var i;
	var plugname, prevplugname, nextplugname, inchan, outchan;

	for(i=0; i < gPlugNames.length; i++)
	{
		plugname = gPlugNames[i];
		inchan = "grn_plugin_input_set"+plugname;
		outchan = "grn_plugin_output_set"+plugname;
		
		// set plugin input
		if (i == 0)
		{
			// set receive from beginning of chain
			sendglobal(inchan, "grn_plugins_input");
		}
		else
		{
			// set receive from previous plug
			prevplugname = gPlugNames[i-1];
			sendglobal(inchan, "grn_plugin"+prevplugname);
		}

		// set output
		if (i == gPlugNames.length-1)
		{
			// set send to end of chain
			sendglobal(outchan, "grn_plugins_output");
		}
		else
		{
			sendglobal(outchan, "grn_plugin"+plugname);	
		}
	}
	
	sendglobal("grn_plugin_count", gPlugNames.length);
}
setplugs.immediate = 1;


