
post ("_rn_record_logic.js\n");
autowatch = 1;

// global varables and code
inlets = 1;
outlets = 1;

const OFF=0;
const PLAYING=1;
const RECORDING=2;
const FILENAME_WAIT=3;

var gLongFile = "<none>";
var gPath = "Desktop/";
var gShortFile = "Untitled.mov";
var gAudioFile = "Untitled_sound";
var gFileRoot = "Untitled";

var gFPS = 29.97;
var gCodec = "raw";

var gAudioBufs = 5; // make variable later
var gBufNames = ["L", "R", "C", "Ls", "Rs"];

// state machine vars
var gTransportState = OFF;

init();

function init()
{
	outlet(0, "rangeslider", 0, 1);				
	gTransportState = OFF;
}

// The only hack I could come up with for this. 
function file_exists(fullname)
{
	var fileObj;
	
	fileObj = new File(fullname);
	exists = (fileObj.eof > 0);
	fileObj.freepeer();	
	return(exists);
}
file_exists.immediate = 1;


// called to set base file name and path, with output of savedialog object.
function setfile(name)
{
	var i, len;
	var c;
	var fileroot, audiofile;

	gLongFile = name;
	len = gLongFile.length;
	
	// strip final slash
	for (i=len; i > 0; i--)
	{
		c = gLongFile.charAt(i);
		if (c == "/")
		{
			gShortFile = gLongFile.slice(i+1, len);
			gPath = gLongFile.slice(0, i+1);
			break;
		}
	}
	
	// add ".mov" if not at end
	len = gShortFile.length;
	if (gShortFile.slice(len-4, len) == ".mov")
	{
		fileroot = gShortFile.slice(0, len-4);
	}
	else
	{
		fileroot = gShortFile;
		gShortFile += ".mov";
		gLongFile += ".mov";
	}
	
	outlet(0, "filepath", "set", gPath);
	outlet(0, "displayname", "set", gShortFile);
	gAudioFile = gPath + fileroot + "_";
	gFileRoot = gPath + fileroot;
	
	if (gTransportState == FILENAME_WAIT)
	{
		record();
	}
}
setfile.immediate = 1;



function play()
{
	if (gTransportState != PLAYING)
	{
		outlet(0, "dac", 0);							
		outlet(0, "nrtflag", 0);
		outlet(0, "qtrecflag", 0);		
		outlet(0, "smpteclock", "fps", gFPS);	
		outlet(0, "smpteclock", "play");	
		outlet(0, "rangeslider", "playing", 1);				
		outlet(0, "dac", 1);							
		gTransportState = PLAYING;
		outlet(0, "state", gTransportState);							
	}
}
play.immediate = 1;


// nonrealtime record.
function record()
{

	if (gTransportState != RECORDING)
	{		
		if (gLongFile == "<none>")
		{		
			gTransportState = FILENAME_WAIT;
			outlet(0, "filedialog", 1);							// trigger file dialog
		}
		else
		{
			gTransportState = RECORDING;
			outlet(0, "nrtflag", 1);							// set nrt flag
			outlet(0, "dac", 0);								// dac off
			outlet(0, "nrtswitch", 1);							// switch driver
			outlet(0, "qtrecflag", 1);							// set qt recording flag
	
post ("render_node: recording to", gLongFile, "\n");
		
			outlet(0, "qtrec", "write", gLongFile, gFPS, gCodec, "max", 600);	// record qt
			outlet(0, "smpteclock", "fps", gFPS);	
			outlet(0, "smpteclock", "record");	
			outlet(0, "rangeslider", "playing", 1);				// enable rangeslider display
			outlet(0, "audiorec", 1);							// start record~
	
			outlet(0, "dac", 1);	
	
		}	
	outlet(0, "state", gTransportState);		
	}
}
record.immediate = 1;


function cancelfile()
{
	post ("Render_node: canceling record.\n");
	gTransportState = OFF;
	outlet(0, "state", gTransportState);		
}
cancelfile.immediate = 1;


function stop() 
{
	var i;
	if (gTransportState == PLAYING)
	{
		outlet(0, "dac", 0);								// dac off
		outlet(0, "rangeslider", "playing", 0);				
	}
	else if (gTransportState == RECORDING)
	{	
		outlet(0, "audiorec", 0);							// stop record~
		outlet(0, "qtrec", "stop");
		outlet(0, "nrtflag", 0);	
		outlet(0, "dac", 0);								// dac off
		for(i=0; i<gAudioBufs; i++)
		{
			post ("writing:", gAudioFile+gBufNames[i]+".aif", "\n");
			// write audio buffers to files.  "b"+i+1 routes to buffer object in patch.
			outlet(0, "audiorec", "b"+(i+1), "writeaiff", gAudioFile+gBufNames[i]+".aif" );	
		}
		outlet(0, "qtrecflag", 0);							// set qt recording flag
		outlet(0, "nrtswitch", 0);							// switch driver
		outlet(0, "rangeslider", "playing", 0);			
		outlet(0, "smpteclock", "dsptime", 0.);	
	}
	gTransportState = OFF;
	outlet(0, "state", gTransportState);							
}
stop.immediate = 1;


function rec_format(f)
{
	switch(f)
	{
		case (0):	// stereo
			gAudioBufs = 2;
		break;
		case (1):	// 5.1
			gAudioBufs = 5;
		break;
	}
}

function fps(fpsstr)
{
	var f = 0.;
	var substr = fpsstr.slice(0, -3);
	f = Number(substr);
	gFPS = f;
post ("FPS:", f, "\n");		
	outlet(0, "smpteclock", "fps", gFPS);	
}
fps.immediate = 1;

function codec(n)
{
	gCodec = n;		
}
codec.immediate = 1;

