
// subframe_texture.js
// jit.gl.texture objects do not resize happily (as of Feb 2006).
// so, this js is here to manage our output texture, destroying the 
// old one and creating a new one in order to resize.


post ("__subframe_texture\n");
autowatch = 1;

// global varables and code
inlets = 1;
outlets = 1;

var myTexture = 0;
var myMatrix = 0;
var tdim = [720, 540];

init();

function init()
{
	rebuild();
}


function rebuild()
{
	if (myTexture)
	{
		myTexture.freepeer();
		myTexture = 0;
	}
	if (myMatrix)
	{
		myMatrix.freepeer();
		myMatrix = 0;
	}
	myTexture = new JitterObject("jit.gl.texture", "rn");
	myMatrix = new JitterMatrix(4, "char", 16, 16);
	if (myTexture)
	{
		myTexture.dim = tdim;
		myTexture.adapt = 0;
		myTexture.name = "rn_subframe";
		post ("texture dim:", myTexture.dim[0], myTexture.dim[1], "\n");
	}
	else
	{
	
		post ("subframe_texture: error, couldn't make texture!\n");
	}
	if (myMatrix)
	{
		myMatrix.name = "black_matrix";
	}
	else
	{
	
		post ("subframe_texture: error, couldn't make matrix!\n");
	}
}


function dim(xdim, ydim)
{
	if ((xdim != tdim[0]) || (ydim != tdim[1]))
	{
		tdim = [xdim, ydim];
		rebuild();
	}
}

function clear()
{
	if (myTexture)
	{
		myTexture.jit_matrix("black_matrix");
	}
}

